<template>
    <header class="fixed w-full top-0 left-0 bg-white shadow-header z-99">
        <div
            class="container flex items-center justify-between mx-auto px-4"
            :class="[isStudent ? 'md:px-52' : 'md:px-8']"
        >
            <div class="flex items-center gap-10">
                <!-- logo -->
                <router-link
                    :to="{ name: routeNameHomePageRole, params: {} }"
                    class="py-2"
                >
                    <img
                        :src="require('@/assets/images/logo.png')"
                        alt=""
                        class="h-12"
                    />
                </router-link>

                <!-- start menu for student -->
                <ul v-if="isStudent" class="main-menu flex items-center gap-8">
                    <li :key="index" v-for="(item, index) in menuFiltered">
                        <router-link
                            :to="{
                                name: item.route.name,
                                params: item.route.params
                            }"
                        >
                            {{ item.text }}
                        </router-link>
                    </li>
                </ul>
            </div>
            <div class="flex items-center gap-3">
                <ListChatHeader />
                <ListNotification />
                <div
                    class="box-user relative"
                    :class="{ active: isActiveMenuUser }"
                >
                    <div
                        v-tooltip:bottom="'Tài khoản'"
                        class="w-10 h-10 rounded-full cursor-pointer"
                    >
                        <img
                            @click="onToggleMenuUser"
                            :src="require('@/assets/images/avatar.png')"
                            alt="avatar"
                            class="w-full rounded-full"
                        />
                    </div>
                    <div
                        class="drop-down-list absolute bg-white shadow-card border rounded-md"
                    >
                        <ul>
                            <li @click="onClickItemUser">
                                <router-link
                                    :to="{ name: 'profile', params: {} }"
                                    class="flex items-center gap-2 p-3 border-b"
                                >
                                    <UserCircleIcon />
                                    <span>Trang cá nhân</span>
                                </router-link>
                            </li>
                            <li>
                                <a
                                    @click="onLogout"
                                    href="javascript:void(0)"
                                    class="flex items-center gap-2 p-3"
                                >
                                    <LogoutIcon />
                                    <span>Đăng xuất</span>
                                </a>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </header>
</template>

<script>
import { ref } from "vue";

import useLogout from "@/hooks/auth/useLogout";

import { UserCircleIcon, LogoutIcon } from "@heroicons/vue/outline";
import ListChatHeader from "@/components/chat/ListChatHeader.vue";
import ListNotification from "@/components/notification/ListNotification.vue";

export default {
    components: {
        UserCircleIcon,
        LogoutIcon,
        ListChatHeader,
        ListNotification
    },
    props: {
        isStudent: {
            type: Boolean,
            required: true
        },
        routeNameHomePageRole: {
            type: String,
            required: true
        },
        menuFiltered: {
            type: Array,
            required: true
        }
    },
    setup() {
        const isActiveMenuUser = ref(false);
        const { logout } = useLogout();

        const onToggleMenuUser = () => {
            isActiveMenuUser.value = !isActiveMenuUser.value;
        };

        const onClickItemUser = () => {
            isActiveMenuUser.value = false;
        };

        document.addEventListener("click", function(e) {
            if (!e.target.closest(".box-user")) {
                onClickItemUser();
            }
        });

        // logout
        async function onLogout() {
            onClickItemUser();
            // show loading
            document.getElementById("full-page-loading").style.display =
                "block";

            await logout();

            // hide loading
            document.getElementById("full-page-loading").style.display = "none";
        }

        return {
            isActiveMenuUser,
            onToggleMenuUser,
            onClickItemUser,
            onLogout
        };
    }
};
</script>

<style lang="scss" scoped>
.box-user {
    &.active .drop-down-list {
        opacity: 1;
        pointer-events: all;
        z-index: 9999;
    }
    .drop-down-list {
        top: 40px;
        right: 0;
        width: 150px;
        pointer-events: none;
        opacity: 0;
        z-index: -1;
        ul li a {
            transition: all ease-in-out 0.1s;
            &:hover {
                @apply bg-main-color-hover-header-2;
            }
        }
    }
}

.main-menu li a {
    &:hover,
    &.router-link-exact-active {
        margin-bottom: -2px;
        border-bottom: 2px solid #7367f0;
    }
}
</style>
